#ifndef DEFINE_FUNC_ATTRIBUTES
# define DEFINE_FUNC_ATTRIBUTES
#endif
#include "nvim/func_attr.h"
#undef DEFINE_FUNC_ATTRIBUTES
void free_buff(buffheader_T *buf);
char_u *get_recorded(void);
char_u *get_inserted(void);
int stuff_empty(void);
int readbuf1_empty(void);
void typeahead_noflush(int c);
void flush_buffers(flush_buffers_T flush_typeahead);
void ResetRedobuff(void);
void CancelRedo(void);
void saveRedobuff(save_redo_T *save_redo);
void restoreRedobuff(save_redo_T *save_redo);
void AppendToRedobuff(const char *s);
void AppendToRedobuffLit(const char_u *str, int len);
void AppendCharToRedobuff(int c);
void AppendNumberToRedobuff(long n);
void stuffReadbuff(const char *s);
void stuffRedoReadbuff(const char *s);
void stuffReadbuffLen(const char *s, long len);
void stuffReadbuffSpec(const char *s);
void stuffcharReadbuff(int c);
void stuffnumReadbuff(long n);
int start_redo(long count, _Bool old_redo);
int start_redo_ins(void);
void stop_redo_ins(void);
int ins_typebuf(char_u *str, int noremap, int offset, int nottyped, _Bool silent);
void ins_char_typebuf(int c);
int typebuf_changed(int tb_change_cnt );
int typebuf_typed(void);
int typebuf_maplen(void);
void del_typebuf(int len, int offset);
void may_sync_undo(void);
void alloc_typebuf(void);
void free_typebuf(void);
void save_typebuf(void);
void save_typeahead(tasave_T *tp);
void restore_typeahead(tasave_T *tp);
void openscript(char_u *name, int directly );
int using_script(void);
void before_blocking(void);
int vgetc(void);
int safe_vgetc(void);
int plain_vgetc(void);
int vpeekc(void);
int vpeekc_any(void);
int char_avail(void);
void vungetc(int c );
int inchar(char_u *buf, int maxlen, long wait_time );
int fix_input_buffer(char_u *buf, int len);
void set_maparg_lhs_rhs(const char_u *orig_lhs, const size_t orig_lhs_len, const char_u *orig_rhs, const size_t orig_rhs_len, int cpo_flags, MapArguments *mapargs);
int str_to_mapargs(const char_u *strargs, _Bool is_unmap, MapArguments *mapargs);
int buf_do_map(int maptype, MapArguments *args, int mode, _Bool is_abbrev, buf_T *buf);
int do_map(int maptype, char_u *arg, int mode, _Bool is_abbrev);
int get_map_mode(char_u **cmdp, int forceit);
void map_clear_mode(char_u *cmdp, char_u *arg, int forceit, int abbr);
void map_clear_int(buf_T *buf, int mode, int local, int abbr );
char *map_mode_to_chars(int mode) FUNC_ATTR_MALLOC FUNC_ATTR_NONNULL_RET;
_Bool map_to_exists(const char *const str, const char *const modechars, const _Bool abbr) FUNC_ATTR_NONNULL_ALL FUNC_ATTR_WARN_UNUSED_RESULT FUNC_ATTR_PURE;
int map_to_exists_mode(const char *const rhs, const int mode, const _Bool abbr);
char_u *set_context_in_map_cmd(expand_T *xp, char_u *cmd, char_u *arg, int forceit, int isabbrev, int isunmap, cmdidx_T cmdidx );
int ExpandMappings(regmatch_T *regmatch, int *num_file, char_u ***file);
int check_abbr(int c, char_u *ptr, int col, int mincol);
char_u *vim_strsave_escape_csi(char_u *p);
void vim_unescape_csi(char_u *p);
int makemap(FILE *fd, buf_T *buf );
int put_escstr(FILE *fd, char_u *strstart, int what);
char_u *check_map(char_u *keys, int mode, int exact, int ign_mod, int abbr, mapblock_T **mp_ptr, int *local_ptr );
void add_map(char_u *map, int mode);
mapblock_T *get_maphash(int index, buf_T *buf) FUNC_ATTR_PURE;
char_u *getcmdkeycmd(int promptc, void *cookie, int indent, _Bool do_concat);
#include "nvim/func_attr.h"
