#ifndef DEFINE_FUNC_ATTRIBUTES
# define DEFINE_FUNC_ATTRIBUTES
#endif
#include "nvim/func_attr.h"
#undef DEFINE_FUNC_ATTRIBUTES
void ui_call_mode_info_set(Boolean enabled, Array cursor_styles);
void ui_call_update_menu(void);
void ui_call_busy_start(void);
void ui_call_busy_stop(void);
void ui_call_mouse_on(void);
void ui_call_mouse_off(void);
void ui_call_mode_change(String mode, Integer mode_idx);
void ui_call_bell(void);
void ui_call_visual_bell(void);
void ui_call_flush(void);
void ui_call_suspend(void);
void ui_call_set_title(String title);
void ui_call_set_icon(String icon);
void ui_call_option_set(String name, Object value);
void ui_call_stop(void);
void ui_call_update_fg(Integer fg);
void ui_call_update_bg(Integer bg);
void ui_call_update_sp(Integer sp);
void ui_call_resize(Integer width, Integer height);
void ui_call_clear(void);
void ui_call_eol_clear(void);
void ui_call_cursor_goto(Integer row, Integer col);
void ui_call_put(String str);
void ui_call_set_scroll_region(Integer top, Integer bot, Integer left, Integer right);
void ui_call_scroll(Integer count);
void ui_call_default_colors_set(Integer rgb_fg, Integer rgb_bg, Integer rgb_sp, Integer cterm_fg, Integer cterm_bg);
void ui_call_hl_attr_define(Integer id, HlAttrs rgb_attrs, HlAttrs cterm_attrs, Array info);
void ui_call_hl_group_set(String name, Integer id);
void ui_call_grid_resize(Integer grid, Integer width, Integer height);
void ui_composed_call_grid_resize(Integer grid, Integer width, Integer height);
void ui_call_grid_clear(Integer grid);
void ui_call_grid_cursor_goto(Integer grid, Integer row, Integer col);
void ui_composed_call_grid_cursor_goto(Integer grid, Integer row, Integer col);
void ui_call_grid_line(Integer grid, Integer row, Integer col_start, Array data);
void ui_call_grid_scroll(Integer grid, Integer top, Integer bot, Integer left, Integer right, Integer rows, Integer cols);
void ui_composed_call_grid_scroll(Integer grid, Integer top, Integer bot, Integer left, Integer right, Integer rows, Integer cols);
void ui_call_grid_destroy(Integer grid);
void ui_call_raw_line(Integer grid, Integer row, Integer startcol, Integer endcol, Integer clearcol, Integer clearattr, LineFlags flags, const schar_T *chunk, const sattr_T *attrs);
void ui_composed_call_raw_line(Integer grid, Integer row, Integer startcol, Integer endcol, Integer clearcol, Integer clearattr, LineFlags flags, const schar_T *chunk, const sattr_T *attrs);
void ui_call_event(char *name, Array args, bool *args_consumed);
void ui_call_win_pos(Integer grid, Window win, Integer startrow, Integer startcol, Integer width, Integer height);
void ui_call_win_float_pos(Integer grid, Window win, String anchor, Integer anchor_grid, Float anchor_row, Float anchor_col, Boolean focusable);
void ui_call_win_external_pos(Integer grid, Window win);
void ui_call_win_hide(Integer grid);
void ui_call_win_close(Integer grid);
void ui_call_msg_set_pos(Integer grid, Integer row, Boolean scrolled, String sep_char);
void ui_composed_call_msg_set_pos(Integer grid, Integer row, Boolean scrolled, String sep_char);
void ui_call_popupmenu_show(Array items, Integer selected, Integer row, Integer col, Integer grid);
void ui_call_popupmenu_hide(void);
void ui_call_popupmenu_select(Integer selected);
void ui_call_tabline_update(Tabpage current, Array tabs);
void ui_call_cmdline_show(Array content, Integer pos, String firstc, String prompt, Integer indent, Integer level);
void ui_call_cmdline_pos(Integer pos, Integer level);
void ui_call_cmdline_special_char(String c, Boolean shift, Integer level);
void ui_call_cmdline_hide(Integer level);
void ui_call_cmdline_block_show(Array lines);
void ui_call_cmdline_block_append(Array lines);
void ui_call_cmdline_block_hide(void);
void ui_call_wildmenu_show(Array items);
void ui_call_wildmenu_select(Integer selected);
void ui_call_wildmenu_hide(void);
void ui_call_msg_show(String kind, Array content, Boolean replace_last);
void ui_call_msg_clear(void);
void ui_call_msg_showcmd(Array content);
void ui_call_msg_showmode(Array content);
void ui_call_msg_ruler(Array content);
void ui_call_msg_history_show(Array entries);
#include "nvim/func_attr.h"
